class Game {
  // attributes
  int points = 0;
  int cases = 0;
  int state = -2; // 0->shooting | 1-> buying | -1 -> gameOver | -2-> game not started
  int fightingTool = 0; // 0-handwash, 1-mask, 2-shield
  int time = 120;
  PImage maskImg = loadImage("mask.png");
  PImage handwashImg = loadImage("handwash.png");
  PImage shieldImg = loadImage("shield.png");
  int timeDisplay = 0;
  int shooterPosition = width/2;
  int shooterDirection = 0;
  float shooterSpeed = 2;
  
  // fighting tools
  // handwash attr
  int handwash = 20;
  
  // facemask attr
  int masks = 14;
  
  // faceshield attr
  int shields = 6;
  
  

  //methods
  void incrementPoints(int type) {
    if (type == 0) {
      points += 1;
    } else if (type == 1) {
      points += 3;
    } else if (type == 2) {
      points += 5;
    }
  }
  
  void incrementCases() {
    cases+=1;
  }

  void incrementMasks() {
    masks+=1;
  }

  void decrementMasks() {
    masks-=1;
  }

  void incrementShields() {
    shields+=1;
  }

  void decrementShields() {
    shields-=1;
  }

  void incrementHandwash() {
    handwash+=1;
  }

  void decrementHandwash() {
    handwash-=1;
  }
  
  void decrementFighters(){
    switch(fightingTool){
      case 0:{
        decrementHandwash();
        break;
      }
      case 1:{
        decrementMasks();
        break;
      }
      case 2:{
        decrementShields();
        break;
      }
    }
  }

  void changeState() {
    //println("changing state");
    if (state==0) {
      state=1;
    } else if (state==1) {
      state=0;
    }
  }
  void updateTime() {
    if (time==0) {
      state=-1;
    }
    if (frameCount%60==0 && state!=-1) {
      time-=1;
      if (timeDisplay==0) {
        timeDisplay = 1;
      } else if (timeDisplay==1) {
        timeDisplay=0;
      }
    }
    if (points==0 && handwash==0 && masks==0 && shields==0){
      state=-1;
    }
  }

  void drawGameStats() {
    textSize(12);
    color(0, 0, 0);
    imageMode(CENTER);
    
    pushStyle();
    //draw handwash
    image(handwashImg, 70, 30, 30, 30); //150,30,30,30
    text(handwash+" x", 25, 30);//110,30

    // draw mask
    image(maskImg, 150, 30, 30, 30);
    text(masks+" x", 110, 30);

    // draw faceshield
    image(shieldImg, 230, 30, 30, 30);
    text(shields+" x", 190, 30);
    popStyle();
    
    //display time
    pushStyle();
    textSize(30);
    if (timeDisplay==1) {
      fill(0, 0, 0);
      text(time, width-100, height-30);
    } else if (timeDisplay==0) {
      fill(255, 255, 0);
      text(time, width-100, height-30);
    }
    popStyle();

    // game mode
    pushStyle();
    int rectWidth = 100;
    int rectHeight = 30;
    int cornerRadius = 10;
    noFill();
    rect(width/2-rectWidth/2, 20, rectWidth, rectHeight, cornerRadius, cornerRadius, cornerRadius, cornerRadius);
    if (state==0) {
      pushStyle();
      textAlign(CENTER);
      textSize(25);
      fill(255, 255, 0);
      text("FIGHT", width/2, 45);
      popStyle();
    } else if (state==1) { //display buy
      pushStyle();
      textAlign(CENTER);
      textSize(25);
      fill(0, 255, 0);
      text("BUY", width/2, 45);
      popStyle();
    } else if (state==-1) { //display gameover
      pushStyle();
      textAlign(CENTER);
      textSize(18);
      fill(255, 0, 0);
      text("Game Over", width/2, 43);
      popStyle();
    }

    popStyle();

    //display points
    pushStyle();
    fill(0, 0, 0);
    textSize(25);
    text(points+" points", width-300, 45);
    text(cases+" cases", width-150, 45);
    popStyle();
  }
  void drawFightingTool(int x, int y, int imgWidth, int imgHeight) {
    pushStyle();
    imageMode(CENTER);
    if (fightingTool==0) { // draw handwash
      image(handwashImg, x, y, imgWidth, imgHeight);
    } else if (fightingTool == 1) { //draw mask
      image(maskImg, x, y, imgWidth, imgHeight);
    } else if (fightingTool == 2) { //draw shield
      image(shieldImg, x, y, imgWidth, imgHeight);
    }
    popStyle();
  }

  void changeFightingTool(int tool) {
    fightingTool = tool;
    //println(fightingTool);
  }

  void shooter() {
    pushStyle();
    fill(255, 255, 255);
    circle(shooterPosition, height, 100);
    game.drawFightingTool(shooterPosition, height-20, 40, 40);
    popStyle();
  }

  void moveShooter() {
    if (shooterSpeed<=2) {
      shooterDirection=0;
      shooterSpeed=2.1;
    }
    if (shooterSpeed>2) {
      shooterPosition += shooterDirection*shooterSpeed;
    }
  }
}
