
// to interact with game
void keyPressed() {
  //println(keyCode);
  switch(keyCode) {
  case 32: 
    { // space bar pressed need to create a new fighter add to list and reduce the number from game class
      if (game.fightingTool==0 && game.handwash>0) {//check number of handwash
        Fighter tempFighter = new Fighter();
        tempFighter.type = game.fightingTool;
        tempFighter.positionX = game.shooterPosition;
        tempFighter.positionY = height-30;
        tempFighter.fighterImage();
        activeFighters.add(tempFighter);
        game.decrementFighters();
      } else if (game.fightingTool==1 && game.masks>0) {//check number of masks
        Fighter tempFighter = new Fighter();
        tempFighter.type = game.fightingTool;
        tempFighter.positionX = game.shooterPosition;
        tempFighter.positionY = height-30;
        tempFighter.fighterImage();
        activeFighters.add(tempFighter);
        game.decrementFighters();
      } else if (game.fightingTool==2 && game.shields>0) {//check number of shields
        Fighter tempFighter = new Fighter();
        tempFighter.type = game.fightingTool;
        tempFighter.positionX = game.shooterPosition;
        tempFighter.positionY = height-30;
        tempFighter.fighterImage();
        activeFighters.add(tempFighter);
        game.decrementFighters();
      }
      break;
    }
  case 37:
    { //move left
      game.shooterDirection = -1;
      if (game.shooterSpeed<10) {
        game.shooterSpeed*=1.1;
      }
      break;
    }
  case 39:
    { //move right
      game.shooterDirection = 1;
      if (game.shooterSpeed<10) {
        game.shooterSpeed*=1.1;
      }
      break;
    }
  case 49:
    { //handwash
      if (game.state==0) {
        game.changeFightingTool(0);
      } else if (game.state==1) { //buy more handwash
        if (game.points>=1) { //check if you have enough points
          game.points-=1;
          game.handwash+=1;
        } else {
          triggerErrorSound();
          errorMessage = "Not Enough Points";
        }
      }
      break;
    }
  case 50:
    { //facemask
      if (game.state==0) {
        game.changeFightingTool(1);
      } else if (game.state==1) { //buy more masks
        if (game.points>=2) { //check if you have enough points
          game.points-=2;
          game.masks+=1;
        } else {
          triggerErrorSound();
          errorMessage = "Not Enough Points";
        }
      }
      break;
    }
  case 51: 
    { //faceshield
      if (game.state==0) {
        game.changeFightingTool(2);
      } else if (game.state==1) { //buy more handwash
        if (game.points>=3) { //check if you have enough points
          game.points-=3;
          game.shields+=1;
        } else {
          triggerErrorSound();
          errorMessage = "Not Enough Points";
        }
      }
      break;
    }
  case 77:
    {
      game.changeState();
      break;
    }
  default:
    {
      triggerErrorSound();
      errorMessage = "Invalid Control";
      break;
    }
  }
}

void keyReleased() {
  if (keyCode==37 || keyCode==39) {
    game.shooterSpeed = 0.8;
  }
}

void flashMessage(String msg, color c, int size, int hOffset) {
  pushStyle();
  fill(c);
  textSize(size);
  text(msg, 10, height-hOffset);
  popStyle();
}

void triggerErrorSound() {
  if (!error.isPlaying()) {
    error.play();
  }
}

void updateCorona() {
  for (int i=0; i<coronaList.size(); i++) {
    coronaList.get(i).updatePosition(height);
    coronaList.get(i).dispVirus();
  }
}

void displayError() {
  if (error.isPlaying()) // // display error message
  {
    color errorColor = color(255, 0, 0); // color of error message
    flashMessage(errorMessage, errorColor, 15, 25); // display error message
  }
}

void displayCost() {
  if (game.state==1) { // display cost of buying more items
    String msg = "Handwash 1  Facemask 2  Faceshield 3"; // message string
    color c = color(53, 50, 56); // color of message
    flashMessage(msg, c, 18, 10); // display message
  }
}

void playBGMusic() {
  if (!scaryBg.isPlaying()) { // play bgMusic
    scaryBg.play();
  }
}

void moveFighters() {
  //activeFighters
  for (int i=0; i<activeFighters.size(); i++) {
    activeFighters.get(i).updatePosition();
  }
}

void checkCollisions() {
  //println("checking collision");                        
  // two for loops. Check as virus against each fighter
  // if collision rem both fighter and virus from arraylist
  // increment point accordingly
  // if fighter above screen remove from array list
  // if virus below screen increment cases and rem from arraylist
  for (int i=0; i<coronaList.size(); i++) {
    println(coronaList.size());
    CoronaVirus tC = coronaList.get(i);
    int size = tC.size;
    //println(size);
    for (int j=0; j<activeFighters.size(); j++) {
      Fighter tF = activeFighters.get(j);
      if (tF.positionX>tC.positionX && tF.positionX<tC.positionX+size) { // this mean the fighter is within the image
        if (tF.positionY>tC.positionY && tF.positionY<tC.positionY+size) { // this means the fighter is within the image
          coronaList.remove(i);
          activeFighters.remove(j);
          game.incrementPoints(tF.type);
          if (!collision.isPlaying()){
            collision.play();
          }
          game.points+=1;
        }
      }
    }
  }
}

void checkCoronaPosition(){
  for(int i=0;i<coronaList.size();i++){
    CoronaVirus tC = coronaList.get(i);
    if (tC.positionY>height){
      game.cases+=1;
      if(!newCase.isPlaying()){
        newCase.play();
      }
      coronaList.remove(i);
    }
  }
}

void checkFighterPosition(){
  for(int i=0;i<activeFighters.size();i++){
    Fighter tF = activeFighters.get(i);
    if (tF.positionY<0){
      activeFighters.remove(i);
    }
  }
}

void newViruses(){
  if (frameCount%7==0 && frameCount%9==0 && frameCount%4==0){
    coronaList.add(new CoronaVirus());
  }
}

void gameOver(){
  // this should display the previous game stats
  background(110,125,171);
  int size = 50;
  pushStyle();
  textSize(24);
  int moveItemsHorizontal = 100;
  image(game.handwashImg,width/2-120+moveItemsHorizontal,height/2-240,size,size);
  text(game.handwash,width/2-80+moveItemsHorizontal,height/2-230);
  
  image(game.maskImg,width/2-120+moveItemsHorizontal,height/2-160,size,size);
  text(game.masks,width/2-80+moveItemsHorizontal,height/2-150);
  
  image(game.shieldImg,width/2-120+moveItemsHorizontal,height/2-80,size,size);
  text(game.masks,width/2-80+moveItemsHorizontal,height/2-70);
  
  textSize(32);
  textAlign(CENTER);
  text("Points "+game.points,width/2,height/2+30);
  text("Cases "+game.cases,width/2,height/2+80);
  popStyle();
  restartButton();
  
}

void restartButton(){
  int buttonYPosition = 200;
  int rectWidth = 250;
  int rectHeight = 70;
  pushStyle();
  rectMode(CENTER);
  fill(9,129,74);
  if (mouseX>width/2-rectWidth/2 && mouseX<width/2+rectWidth/2 && mouseY>height/2+buttonYPosition-rectHeight/2 && mouseY<height/2+buttonYPosition+rectHeight/2){
    fill(9,160,74);
    if (mousePressed){
      resetGame();
      fill(9,100,74);
    }
  }
  rect(width/2,height/2+buttonYPosition,rectWidth,rectHeight,30);
  textAlign(CENTER);
  fill(0,0,0);
  textSize(40);
  text("RESTART",width/2,height/2+buttonYPosition+15);
  popStyle();
}

void resetGame(){
  game = new Game();
  coronaList = new ArrayList<CoronaVirus>(0);
  activeFighters = new ArrayList<Fighter>(0);
  game.state = 0;
  for (int i=0; i<4; i++) {
    coronaList.add(new CoronaVirus());
  }
}

void startScreen(){
  background(110,125,171);
  image(virus,20,20,500,500);
  instructions();
  startButton();
}

void startButton(){
  int moveButton = 85;
  int buttonYPosition = 200;
  int rectWidth = 250;
  int rectHeight = 70;
  pushStyle();
  rectMode(CENTER);
  fill(9,129,74);
  if (mouseX>width/2-rectWidth/2 && mouseX<width/2+rectWidth/2 && mouseY>height/2+buttonYPosition-rectHeight/2+moveButton && mouseY<height/2+buttonYPosition+rectHeight/2+moveButton){
    fill(9,160,74);
    if (mousePressed){
      game.state=0;
      fill(9,100,74);
    }
  }
  rect(width/2,height/2+buttonYPosition+moveButton,rectWidth,rectHeight,30);
  textAlign(CENTER);
  fill(0,0,0);
  textSize(40);
  text("START",width/2,height/2+buttonYPosition+15+moveButton);
  popStyle();
}

void instructions(){
  // Title
  pushStyle();
  String title = "Pandemic";
  fill(178,103,0);
  stroke(178,103,0);
  strokeWeight(3);
  textAlign(CENTER);
  textSize(48);
  text(title,width/2,60);
  popStyle();
  
  //objective heading
  pushStyle();
  String objective = "Objective";
  fill(0,0,0);
  textAlign(LEFT);
  textSize(32);
  text(objective,width/2,150);
  popStyle();
  
  //objective text
  pushStyle();
  String objectiveText = "Try to get your points as high as possible while keeping the number of the cases as low as possible";
  fill(0,0,0);
  textAlign(LEFT);
  textSize(18);
  text(objectiveText,width/2+50,180, width/2-70,250);
  popStyle();
  
  //instruction heading
  pushStyle();
  String instruction = "Instructions";
  fill(0,0,0);
  textAlign(LEFT);
  textSize(32);
  text(instruction,width/2,280);
  popStyle();
  
  //objective text
  String line1 = "1. Move the shooter across the screen by using the left and right arrow keys.\n";
  String line2 = "2. The icon shown in the shooter will be what you will be shooting down the virus with.\n";
  String line3 = "3. Shooting the virus down with different tools will yield different points.\n";
  String line4 = "4. The tools which yield greater points are also more expensive to acquire.\n";
  String line5 = "5. You can choose the tool that you’re fighting with by pressing 1,2 or 3. 1 will select the handwash, 2 will select facemask and 3 will select a face shield.\n";
  String line6 = "6. You can acquire more tools by pressing m to go into buying mode and then pressing 1,2 or 3 to acquire more tools. A hand wash will cost 1 point, a face mask will cost 2 points and a face shield will cost 3 points.\n";
  String line7 = "7. Number of cases will increase is the virus goes below the screen.";
  pushStyle();
  String instructionText = line1+line2+line3+line4+line5+line6+line7;
  fill(0,0,0);
  textAlign(LEFT);
  textSize(15);
  text(instructionText,width/2+50,300, width/2-70,700);
  popStyle();
}
