import processing.sound.*;

//create new game
Game game;

// arrayList to store corona virus images
ArrayList <CoronaVirus> coronaList;
ArrayList <Fighter> activeFighters;

//sound files
SoundFile error;
SoundFile scaryBg;
SoundFile collision;
SoundFile newCase;

//image
PImage virus;

// misc vars
String errorMessage = "";

void setup() {
  size(1280, 720);
  game = new Game(); //init game
  coronaList = new ArrayList<CoronaVirus>(0);
  activeFighters = new ArrayList<Fighter>(0);
  for (int i=0; i<4; i++) {
    coronaList.add(new CoronaVirus());
  }
  virus = loadImage("virus.png");
  error = new SoundFile(this, "error.mp3");
  scaryBg = new SoundFile(this, "scaryBg.mp3");
  collision = new SoundFile(this, "collide.mp3");
  newCase = new SoundFile(this, "dead.mp3");
}

void draw() {
  if (game.state==-2) {
    startScreen();
  }
  else if (game.state==0 || game.state==1) {
    background(211, 211, 211); // clear background to avoid trails
    game.drawGameStats(); // show the game statistics
    game.shooter(); // draw the shooter
    displayError(); //display error messages
    displayCost(); // display cost of buying
    playBGMusic(); // play background music
    updateCorona(); // update the position and display the virus
    moveFighters(); //move the fighting tools on the screen
    checkCollisions(); //check for collision
    checkCoronaPosition(); // check for off screen viruses
    checkFighterPosition(); // check for off screen fighting tool
    newViruses(); // generate new viruses
    game.moveShooter(); // move the shooter
    game.updateTime(); // countdown time
  }
  else if (game.state==-1) {
    gameOver();
  }
}
